"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const React = require("react");
function TokenElement(props) {
    const { token } = props;
    if (typeof token === 'string') {
        return React.createElement("span", null, token);
    }
    if (Array.isArray(token)) {
        return React.createElement("span", null, token.map((t, i) => React.createElement(TokenElement, { token: t, key: i })));
    }
    let classes = ['token', token.type];
    if (token.alias) {
        const aliases = Array.isArray(token.alias) ? token.alias : [token.alias];
        classes.push(...aliases);
    }
    if (props.customClasses) {
        const { customClasses } = props;
        classes = classes.map((c) => {
            return ((customClasses.prefix || '') +
                (customClasses.map && Object.prototype.hasOwnProperty.call(customClasses.map, c)
                    ? customClasses.map[c]
                    : c));
        });
    }
    return (React.createElement("span", { className: classes.join(' ') },
        React.createElement(TokenElement, { token: token.content })));
}
exports.TokenElement = TokenElement;
